/// <reference types="node" />
/// <reference types="node" />
import http from 'http';
import https from 'https';
type AgentType = http.Agent | https.Agent;
export declare function bindHttpMethod(originalMethod: (...args: unknown[]) => unknown, agent: AgentType, forceGlobalAgent: boolean): (...args: unknown[]) => unknown;
/**
 * @property forceGlobalAgent Forces to use `global-proxy-agent` HTTP(S) agent even when request was explicitly constructed with another agent. (Default: `true`)
 * @property http Defines that http module should use proxy. (Default: `true`)
 * @property https Defines that https module should use proxy. (Default: `true`)
 */
export interface GlobalProxyAgentOptions {
    forceGlobalAgent?: boolean;
    http?: boolean;
    https?: boolean;
}
/**
 * enableGlobalProxyAgent replaces http.globalAgent/https.globalAgent with provided proxyAgent
 * @param proxyAgent
 * @param options
 * @see https://github.com/gajus/global-agent
 * @return disableGlobalProxyAgent - Disables globalProxyAgent
 */
export declare function enableGlobalProxyAgent(proxyAgent: AgentType, options?: GlobalProxyAgentOptions): () => void;
export {};
//# sourceMappingURL=index.d.ts.map